VERSION 5.00
Object = "{BDC217C8-ED16-11CD-956C-0000C04E4C0A}#1.1#0"; "TABCTL32.OCX"
Object = "{ECEDB943-AC41-11D2-AB20-000000000000}#2.0#0"; "CMAX20.OCX"
Begin VB.Form frmPropTransicion 
   Caption         =   "Transition properties"
   ClientHeight    =   6330
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8385
   LinkTopic       =   "Form1"
   MinButton       =   0   'False
   ScaleHeight     =   6330
   ScaleWidth      =   8385
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkContinueImmediately 
      Caption         =   "Continue immediately"
      Height          =   255
      Left            =   5880
      TabIndex        =   11
      Top             =   240
      Value           =   1  'Checked
      Width           =   2175
   End
   Begin VB.CheckBox chkMustBeLast 
      Caption         =   "This must be the last transition"
      Height          =   255
      Left            =   3000
      TabIndex        =   8
      Top             =   240
      Value           =   1  'Checked
      Width           =   2655
   End
   Begin TabDlg.SSTab SSTab1 
      Height          =   5175
      Left            =   120
      TabIndex        =   5
      Top             =   600
      Width           =   8175
      _ExtentX        =   14420
      _ExtentY        =   9128
      _Version        =   393216
      Tabs            =   2
      TabsPerRow      =   2
      TabHeight       =   520
      TabCaption(0)   =   "Condition"
      TabPicture(0)   =   "PropTransicion.frx":0000
      Tab(0).ControlEnabled=   -1  'True
      Tab(0).Control(0)=   "Label1"
      Tab(0).Control(0).Enabled=   0   'False
      Tab(0).Control(1)=   "txtCondicion"
      Tab(0).Control(1).Enabled=   0   'False
      Tab(0).ControlCount=   2
      TabCaption(1)   =   "Action"
      TabPicture(1)   =   "PropTransicion.frx":001C
      Tab(1).ControlEnabled=   0   'False
      Tab(1).Control(0)=   "txtAccion"
      Tab(1).Control(1)=   "lblAcciones"
      Tab(1).ControlCount=   2
      Begin CodeMaxCtl.CodeMax txtAccion 
         Height          =   4440
         Left            =   -74880
         OleObjectBlob   =   "PropTransicion.frx":0038
         TabIndex        =   9
         Top             =   600
         Width           =   7935
      End
      Begin CodeMaxCtl.CodeMax txtCondicion 
         Height          =   4440
         Left            =   120
         OleObjectBlob   =   "PropTransicion.frx":01A8
         TabIndex        =   10
         Top             =   600
         Width           =   7935
      End
      Begin VB.Label lblAcciones 
         AutoSize        =   -1  'True
         Caption         =   "Transition actions (Meally Style):"
         Height          =   195
         Left            =   -74760
         TabIndex        =   7
         ToolTipText     =   "Actions to be done when the condition is true"
         Top             =   360
         Width           =   2265
      End
      Begin VB.Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "Transition condition:"
         Height          =   195
         Left            =   240
         TabIndex        =   6
         ToolTipText     =   "Condition that permit the transition"
         Top             =   360
         Width           =   1425
      End
   End
   Begin VB.CheckBox chkSelfTransition 
      Caption         =   "This SelfTransition can cause entry && exit actions"
      Height          =   255
      Left            =   3000
      TabIndex        =   1
      Top             =   0
      Value           =   1  'Checked
      Visible         =   0   'False
      Width           =   4095
   End
   Begin VB.TextBox txtPrioridad 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   1920
      MaxLength       =   4
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
   Begin VB.CommandButton cmdCancelar 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4320
      TabIndex        =   3
      Top             =   5880
      Width           =   3855
   End
   Begin VB.CommandButton cmdValidar 
      Caption         =   "OK"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   5880
      Width           =   3855
   End
   Begin VB.Label lblPrioridad 
      AutoSize        =   -1  'True
      Caption         =   "Transition priority:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   240
      TabIndex        =   4
      ToolTipText     =   "Priority in the analysis of the transition"
      Top             =   120
      Width           =   1545
   End
End
Attribute VB_Name = "frmPropTransicion"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Constantes necesarias para permitir resize
Private Const DEF_WND_HEIGHT As Single = 6735
Private Const DEF_WND_WIDTH As Single = 8505
Private Const DEF_CMD_OK_TOP As Single = 5880
Private Const DEF_CMD_CANCEL_TOP As Single = 5880
Private Const DEF_TAB_HEIGHT As Single = 5175
Private Const DEF_TAB_WIDTH As Single = 8175
Private Const DEF_TXT_HEIGHT As Single = 4440
Private Const DEF_TXT_WIDTH As Single = 7935

'Estructuras para comparacin
Private Type tipoEstadoAnterior
    prioridad As String
    condicion As String
    accion As String
    entryExitSelfTr As Boolean
    mustBeLast As Boolean
    continueImmediately As Boolean
End Type
Private anterior  As tipoEstadoAnterior
Private bBypassReindexMessage As Boolean
Private bAvoidTabSubst As Boolean


'Control de posicion de los botones mviles
Private Sub Form_Resize()
Dim dx As Single
Dim dy As Single
    With Me
        
        'Mide incremento respecto a posicion por defecto
        dx = .Height - DEF_WND_HEIGHT
        If dx < 0 Then
            .Height = DEF_WND_HEIGHT
            dx = 0
        End If
        dy = .Width - DEF_WND_WIDTH
        If dy < 0 Then
            .Width = DEF_WND_WIDTH
            dy = 0
        End If

        'Reajusta frames y botones
        .cmdValidar.top = DEF_CMD_OK_TOP + dx
        .cmdCancelar.top = DEF_CMD_CANCEL_TOP + dx
        
        'Reajusta men de solapa
        .SSTab1.Height = DEF_TAB_HEIGHT + dx
        .SSTab1.Width = DEF_TAB_WIDTH + dy
        
        .txtCondicion.Height = DEF_TXT_HEIGHT + dx
        .txtCondicion.Width = DEF_TXT_WIDTH + dy
        .txtAccion.Height = .txtCondicion.Height
        .txtAccion.Width = .txtCondicion.Width
    End With
End Sub

'Memoriza estado inicial
Private Sub MemorizaEstadoInicial()
    anterior.prioridad = txtPrioridad.Text
    anterior.condicion = txtCondicion.Text
    anterior.accion = txtAccion.Text
    anterior.entryExitSelfTr = (chkSelfTransition.Value = vbChecked)
    anterior.mustBeLast = (chkMustBeLast.Value = vbChecked)
    anterior.continueImmediately = (chkContinueImmediately.Value = vbChecked)
End Sub

Private Function HaCambiadoElContenido() As Boolean
    HaCambiadoElContenido = anterior.prioridad <> txtPrioridad.Text Or _
                            anterior.condicion <> txtCondicion.Text Or _
                            anterior.accion <> txtAccion.Text Or _
                            anterior.entryExitSelfTr <> (chkSelfTransition.Value = vbChecked) Or _
                            anterior.mustBeLast <> (chkMustBeLast.Value = vbChecked) Or _
                            anterior.continueImmediately <> (chkContinueImmediately.Value = vbChecked)
End Function

Private Sub CargaBoxes()
Dim grafo As AddFlow
Dim link As afLink
Dim bHideChkMustBeLast As Boolean
    
    Set grafo = mainFrm.ActiveForm.AddFlow1
    With grafo
        If .readOnly Then
            cmdValidar.enabled = False
            txtPrioridad.Locked = True
            txtPrioridad.BackColor = COLOR_AMARILLO
            txtCondicion.readOnly = True
            txtCondicion.SetColor cmClrWindow, COLOR_AMARILLO
            txtAccion.readOnly = True
            txtAccion.SetColor cmClrWindow, COLOR_AMARILLO
            chkSelfTransition.enabled = False
            chkMustBeLast.enabled = False
            chkContinueImmediately.enabled = False
        Else
            cmdValidar.enabled = True
            txtPrioridad.Locked = False
            txtPrioridad.BackColor = COLOR_FONDOVENTANA
            txtCondicion.readOnly = False
            txtCondicion.SetColor cmClrWindow, COLOR_FONDOVENTANA
            txtAccion.readOnly = False
            txtAccion.SetColor cmClrWindow, COLOR_FONDOVENTANA
            chkSelfTransition.enabled = True
            chkMustBeLast.enabled = True
            chkContinueImmediately.enabled = True
        End If
        
        cMax.GetConfig txtCondicion
        cMax.GetConfig txtAccion
        
        txtPrioridad.Text = DimeDatoTrans(PRIORITY, .SelectedNode)
        txtCondicion.Text = DimeDatoTrans(CONDITIONS, .SelectedNode)
        txtAccion.Text = DimeDatoTrans(ACTIONS_MEALY, .SelectedNode)

        chkSelfTransition.Visible = (.SelectedNode.InLinks(1).org Is .SelectedNode.OutLinks(1).dst)
        chkSelfTransition.Value = IIf(DimeDatoTrans(ENTRY_EXIT_SELF_TRANS, grafo.SelectedNode) <> "N", vbChecked, vbUnchecked)

        'Comprueba si existe ya una transicion marcada como final
        For Each link In .SelectedNode.InLinks(1).org.OutLinks
            If EsTransicion(link.dst) Then
                If DimeDatoTrans(MUST_BE_LAST, link.dst) = "Y" Then
                    If Not (link.dst Is .SelectedNode) Then
                        bHideChkMustBeLast = True
                        Exit For
                    End If
                End If
            End If
        Next
        chkMustBeLast.enabled = chkMustBeLast.enabled And Not (bHideChkMustBeLast)
        chkMustBeLast.Value = IIf(DimeDatoTrans(MUST_BE_LAST, grafo.SelectedNode) = "Y", vbChecked, vbUnchecked)
        
        chkContinueImmediately.Value = IIf(DimeDatoTrans(CONTINUE_IMMEDIATELY, grafo.SelectedNode) = "Y", vbChecked, vbUnchecked)

    End With

    MemorizaEstadoInicial
End Sub



Private Sub Form_Load()
Dim W As Single, h As Single
   
    bAvoidTabSubst = False
    h = GetSetting(App.Title, "PropTrans", "WndHeight", DEF_WND_HEIGHT)
    W = GetSetting(App.Title, "PropTrans", "WndWidth", DEF_WND_WIDTH)

    If W = 0 And h = 0 Then
        WindowState = vbMaximized
    Else
        Me.Height = h
        Me.Width = W
    End If

    Me.top = (Screen.Height - Me.Height) / 2
    Me.Left = (Screen.Width - Me.Width) / 2
    SSTab1.Tab = 0
    
    CargaBoxes
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim W As Single, h As Single
    If WindowState = vbNormal Then
        h = Me.Height
        W = Me.Width
    Else
        h = 0
        W = 0
    End If
    SaveSetting App.Title, "PropTrans", "WndHeight", h
    SaveSetting App.Title, "PropTrans", "WndWidth", W
End Sub

Private Sub chkMustBeLast_Click()
    If chkMustBeLast.Value = vbChecked Then
        txtPrioridad.Text = Format$(MAX_TRANS_PRIORITY)
        bBypassReindexMessage = True
        txtPrioridad_LostFocus
    End If
End Sub


Private Sub txtPrioridad_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then
        txtCondicion.SetFocus
    End If
End Sub

Private Sub txtPrioridad_LostFocus()
Dim v As Long
Dim grafo As AddFlow
    
    v = Val(txtPrioridad.Text)
    txtPrioridad.Text = Format$(v)
    If v <= 0 Or v > MAX_TRANS_PRIORITY Then
        MsgBox "Illegal priority, try other different"
        txtPrioridad.SetFocus
        Exit Sub
    End If
    
    If anterior.prioridad <> txtPrioridad.Text Then
        If Not bBypassReindexMessage Then
            bBypassReindexMessage = (MsgBox("This can reorganize all priorities of this node", vbOKCancel, "The priority has changed") = vbOK)
        End If
        If bBypassReindexMessage Then
            bBypassReindexMessage = False
            Set grafo = mainFrm.ActiveForm.AddFlow1
            With grafo
                'Primero actualiza la prioridad del nodo seleccionado
                Configura_Nodo_Transicion txtPrioridad.Text, _
                                          txtCondicion.Text, _
                                          txtAccion.Text, _
                                          IIf(chkSelfTransition.Value = vbChecked, "Y", "N"), _
                                          IIf(chkMustBeLast.Value = vbChecked, "Y", "N"), _
                                          IIf(chkContinueImmediately.Value = vbChecked, "Y", "N"), _
                                          .SelectedNode
                
                'Recalcula todas las prioridades que parten del nodo Estado origen
                Normaliza_Prioridades .SelectedNode.InLinks(1).org, .SelectedNode
                txtPrioridad.Text = DimeDatoTrans(PRIORITY, .SelectedNode)
            End With
            anterior.prioridad = txtPrioridad.Text
        Else
            txtPrioridad.Text = anterior.prioridad
        End If
    End If
End Sub

Private Sub cmdValidar_Click()
Dim grafo As AddFlow
    If HaCambiadoElContenido Then
        Set grafo = mainFrm.ActiveForm.AddFlow1
        Configura_Nodo_Transicion txtPrioridad.Text, _
                                  txtCondicion.Text, _
                                  txtAccion.Text, _
                                  IIf(chkSelfTransition.Value = vbChecked, "Y", "N"), _
                                  IIf(chkMustBeLast.Value = vbChecked, "Y", "N"), _
                                  IIf(chkContinueImmediately.Value = vbChecked, "Y", "N"), _
                                  grafo.SelectedNode
    End If
    Unload Me
End Sub
Private Sub cmdCancelar_Click()
    Unload Me
End Sub

Public Function Buscar(sBuscar As String, sAReemplazar As String, caseSensitive As Boolean) As Boolean
Dim s As String
Dim sPadre As String
Dim sComentario As String
Dim grafo As AddFlow
    
    CargaBoxes
    
    Set grafo = mainFrm.ActiveForm.AddFlow1
    With grafo
        sPadre = DimeDatoEstado(ESTADO_NAME, .SelectedNode.InLinks(1).org)
        sComentario = "Transition(" & txtPrioridad.Text & ") from [" & sPadre & "]: "
        s = txtCondicion.Text
        If frmFind.busqueda(sComentario & "Condition", s, sBuscar, sAReemplazar, caseSensitive, .readOnly) Then
            txtCondicion.Text = s
            s = txtAccion.Text
            If frmFind.busqueda(sComentario & "Actions ", s, sBuscar, sAReemplazar, caseSensitive, .readOnly) Then
                txtAccion.Text = s
                Buscar = True 'Permite seguir buscando
            End If
        End If
        If .readOnly Then
            Unload Me
        Else
            cmdValidar_Click
        End If
    End With
End Function


Private Sub txtCondicion_GotFocus()
    cMax.GetConfig txtCondicion
End Sub
Private Sub txtCondicion_LostFocus()
    cMax.SetConfig txtCondicion
    If Not bAvoidTabSubst Then txtCondicion.Text = SubstTabBySpaces(MarcadoresAnsiC(Trim$(txtCondicion.Text), 0, False))
End Sub
Private Sub txtAccion_GotFocus()
    cMax.GetConfig txtAccion
End Sub
Private Sub txtAccion_LostFocus()
    cMax.SetConfig txtAccion
    If Not bAvoidTabSubst Then txtAccion.Text = SubstTabBySpaces(Trim$(txtAccion.Text))
End Sub

'Repository interfaces
Private Function txtCondicion_KeyDown(ByVal Control As CodeMaxCtl.ICodeMax, ByVal KeyCode As Long, ByVal Shift As Long) As Boolean
    If KeyCode = vbKeyF2 Then
        bAvoidTabSubst = True
        frmRepositorio.Edita txtCondicion, Nothing, 2
        bAvoidTabSubst = False
    End If
End Function
Private Function txtAccion_KeyDown(ByVal Control As CodeMaxCtl.ICodeMax, ByVal KeyCode As Long, ByVal Shift As Long) As Boolean
    If KeyCode = vbKeyF2 Then
        bAvoidTabSubst = True
        frmRepositorio.Edita txtAccion, Nothing, 2
        bAvoidTabSubst = False
    End If
End Function
