Attribute VB_Name = "modConsulta"
'+++ by Rolf
Option Explicit

Public Function EsComentario(nodo As afNode) As Boolean
    If Not (nodo Is Nothing) Then
        EsComentario = nodo.UserData And NODO_TEXTO
    Else
        EsComentario = False
    End If
End Function

Public Function EsAceptable_CopiarPegar(grafo As AddFlow) As Boolean
Dim nodo As afNode
    'Busca nodos logicos en la seleccion
    For Each nodo In grafo.SelNodes
        If nodo.Logical Then
            EsAceptable_CopiarPegar = False
            Exit Function
        End If
    Next
    
    If grafo.SelLinks.count Then
        EsAceptable_CopiarPegar = False
    Else
        EsAceptable_CopiarPegar = True
    End If
End Function
Public Function TienePadre(frm As frmDoc) As Boolean
Dim barraPos As Integer
Dim sFilePadre As String
Dim sFile As String

    sFile = frm.sFullDocname
    barraPos = InStrRev(sFile, "\")
    If barraPos = 0 Then
        TienePadre = False
        Exit Function
    End If
    
    sFilePadre = Left$(sFile, barraPos - 1) & ".fsm"
    If FileExist(sFilePadre, vbNormal + vbReadOnly) Then
        frm.sPadre = sFilePadre
        TienePadre = True
    Else
        TienePadre = False
    End If
End Function

Public Function LinksHijos(frm As frmDoc) As Boolean
Dim i As Long
Dim parent  As New clsParientes
    
    'Busca todos hijos posibles
    parent.BuscaTodosEnlaces frm.AddFlow1
    
    'Recarga ButtomMenus
    mainFrm.tbToolBar.Buttons("GoDown1Level").ButtonMenus.Clear
    For i = 1 To parent.DimeNumeroHijos
        'Crea la ruta completa
        mainFrm.tbToolBar.Buttons("GoDown1Level").ButtonMenus.Add , , parent.DimeHijo(i)
    Next
    
    LinksHijos = parent.DimeNumeroHijos > 0
End Function
