VERSION 5.00
Begin VB.Form frmFind 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find string"
   ClientHeight    =   3315
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8385
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3315
   ScaleWidth      =   8385
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrReinicia 
      Enabled         =   0   'False
      Interval        =   20
      Left            =   8040
      Top             =   3120
   End
   Begin VB.CommandButton cmdSustituir 
      Caption         =   "Change"
      Height          =   375
      Left            =   5640
      TabIndex        =   4
      Top             =   2880
      Width           =   2535
   End
   Begin VB.CommandButton cmdContinuar 
      Caption         =   "Next (F3)"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   2880
      Width           =   2535
   End
   Begin VB.CommandButton cmdCancelar 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Top             =   2880
      Width           =   2535
   End
   Begin VB.TextBox txtFind 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2280
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   480
      Width           =   8175
   End
   Begin VB.Label lblInfo 
      BackColor       =   &H00FFFFC0&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   8175
   End
End
Attribute VB_Name = "frmFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private sADevolver As String
Private sBuscada As String
Private sReemplazo As String
Private seguir As Boolean
Private bCaseSensitive As Boolean
Private x As Integer
Private y As Integer

Private Sub cmdCancelar_Click()
    seguir = False
    Unload Me
End Sub

Private Sub cmdSustituir_Click()
    txtFind.SelText = sReemplazo
    cmdContinuar_Click
End Sub


Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyF3 Then cmdContinuar_Click
'    If KeyCode = vbKeyEscape Then cmdCancelar_Click
End Sub
Private Sub cmdContinuar_Click()
    If BuscarEnTextBox(txtFind, sBuscada, bCaseSensitive, txtFind.SelStart + txtFind.SelLength + 1) Then
        txtFind.SetFocus
    Else
        sADevolver = txtFind.Text
        Unload Me
    End If
End Sub

Public Function busqueda(titulo As String, ByRef texto As String, sBusc As String, sAReemplazar As String, caseSensitive As Boolean, readOnly As Boolean) As Boolean
    lblInfo.Caption = titulo
    txtFind.Text = texto
    txtFind.Locked = readOnly
    If readOnly Then
        txtFind.BackColor = COLOR_AMARILLO
    Else
        txtFind.BackColor = COLOR_FONDOVENTANA
    End If
    
    bCaseSensitive = caseSensitive

    seguir = True
    
    'Guarda cadena inicial y cadena a buscar
    sADevolver = txtFind.Text
    sBuscada = sBusc
    sReemplazo = sAReemplazar
    
    'Comprueba si procede presentar formulario
    If BuscarEnTextBox(txtFind, sBuscada, bCaseSensitive) Then
        'Configura panel
        If (sReemplazo = vbNullChar) Or readOnly Then
            cmdSustituir.enabled = False
        Else
            cmdSustituir.default = True
        End If
        tmrReinicia.enabled = True
        frmLib_LinkInstance.Stopped
        frmFind.Show vbModal
        frmLib_LinkInstance.Running
    End If
    'Devuelve la cadena encontrada
    texto = sADevolver
    busqueda = seguir
    Unload Me
End Function


Private Sub Form_Load()
    If x = 0 And y = 0 Then
        x = (Screen.Height - Height) / 2
        y = (Screen.Width - Width) / 2
    End If
    top = x
    Left = y
End Sub

Private Sub Form_Unload(Cancel As Integer)
    x = top
    y = Left
End Sub

'Para que busque la posicion con el scroll ya que si esta escondido
'por defecto no lo localiza ya que lo encontro en modo hide
Private Sub tmrReinicia_Timer()
    tmrReinicia.enabled = False
    BuscarEnTextBox txtFind, sBuscada, bCaseSensitive
End Sub


'Repository interfaces
Private Sub txtFind_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyF2 Then
        frmRepositorio.Edita Nothing, txtFind, 1
    ElseIf KeyCode = vbKeyTab And Shift = vbCtrlMask Then
        AppendTab txtFind
        KeyCode = 0
        Shift = 0
    End If
End Sub


'Insert tabulations of spacesPerTab spaces in the Textbox in the position SelStart
Private Sub AppendTab(ByRef txtBox As TextBox, Optional spacesPerTab As Integer = 4)
Dim posInitLine As Long
Dim numSpaces As Long
    If txtBox.SelStart > 0 Then
        posInitLine = InStrRev(txtBox.Text, vbLf, txtBox.SelStart)
    Else
        posInitLine = 0
    End If
'    txtBox.SelLength = 0
    numSpaces = spacesPerTab - ((txtBox.SelStart - posInitLine) Mod spacesPerTab)
    txtBox.SelText = Space$(numSpaces)
End Sub

