Attribute VB_Name = "modHTML"
Option Explicit


Public Function TextoHTML(origen As String, iSangrado As Long) As String
Dim i As Long
Dim ch As String
Dim line As String
Dim sSangrado As String

    For i = 1 To iSangrado
        sSangrado = sSangrado & "&nbsp;"
    Next

    For i = 1 To Len(origen)
        ch = Mid$(origen, i, 1)
        Select Case ch
            Case vbCr
'                ProcesaHipertext line
                TextoHTML = TextoHTML & sSangrado & line & "<BR>" & vbNewLine
                line = vbNullString
                ch = vbNullString
            Case vbLf
                ch = vbNullString
            Case "<"
                ch = "&lt;"
            Case ">"
                ch = "&gt;"
            Case "&"
                ch = "&amp;"
            Case Chr$(34)
                ch = "&quot;"
            Case "|"
                ch = "&brvbar;"
            Case ""
                ch = "&iexcl;"
            Case " "
                ch = "&#32;"
            Case Else
        End Select
        line = line & ch
    Next
    TextoHTML = TextoHTML & sSangrado & line
End Function
Public Function LinksHTML(frm As frmDoc, linksOnSameDir As Boolean) As String
Dim i As Long
Dim parent  As New clsParientes
Dim ruta As String
    
    'Busca todos hijos posibles
    parent.BuscaTodosEnlaces frm.AddFlow1
    
    LinksHTML = "<BR>" + vbNewLine
    For i = 1 To parent.DimeNumeroHijos
        'Crea la ruta relativa
        ruta = FileSinExtension(parent.RutaRelativa(parent.DimeHijo(i))) & ".htm"
        If linksOnSameDir Then
            ruta = ".\" & FileSinRuta(ruta)
        End If
        LinksHTML = LinksHTML & "<A HREF=""" & ruta & """>" & _
                    FileSinRuta(ruta) & "<A>" & "<BR>" & vbNewLine
    Next
End Function


Public Sub AddDummyNode(grafo As AddFlow)
Dim nodo As afNode
Dim x As Single, xMax As Single
Dim y As Single, yMax As Single

    'Elimina textos ya que la info ya reside en el .Tag
    grafo.LogicalOnly = False
    For Each nodo In grafo.Nodes
        With nodo
            x = .Left + .Width
            y = .top + .Height
        End With
        If x > xMax Then xMax = x
        If y > yMax Then yMax = y
    Next
    grafo.LogicalOnly = True
    
    ' Create a dummy node to resize the diagram
    Set nodo = grafo.Nodes.Add(xMax, yMax, 1000, 1000)
    nodo.Hidden = True
    nodo.Logical = False
    nodo.UserData = NODO_DUMMY
End Sub


Public Sub RemoveDummyNode(grafo As AddFlow)
Dim nodo As afNode

    'Locate the dummy node to remove it
    grafo.LogicalOnly = False
    For Each nodo In grafo.Nodes
        nodo.Marked = ((nodo.UserData And NODO_DUMMY) = NODO_DUMMY)
    Next
    grafo.DeleteMarked
    grafo.LogicalOnly = True
End Sub
