Attribute VB_Name = "modModifica"
Option Explicit
'Private centro As tipoCoordenada

'Crea un nodo de texto vaco en la esquina superior izda.
Public Sub CreaComentario(frm As frmDoc)
Dim nodo As afNode
    With frm.AddFlow1
        'Aade el nodo de tipo Decisin
        Set nodo = .Nodes.Add(10, 10, 500, 500)
        nodo.ForeColor = 0
        nodo.FillColor = &HFFFFFF
        nodo.DrawColor = vbBlack
        nodo.UserData = NODO_TEXTO
        nodo.Shape = afRectangle
        nodo.ZOrder = True
        nodo.Transparent = True
        nodo.Logical = False
    End With
End Sub


Public Sub DejaSoloEsteOutLink(linkNuevo As afLink)
Dim link As afLink
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    For Each link In linkNuevo.org.OutLinks
        If link Is linkNuevo Then
            link.Marked = False
        Else
            link.Marked = True
        End If
    Next
    grafo.DeleteMarked
    
    'Normalizing piorities & refresh
    Actualiza_Grafo grafo
End Sub

Public Sub DejaSoloEsteInLink(linkNuevo As afLink)
Dim link As afLink
Dim grafo As AddFlow
    Set grafo = mainFrm.ActiveForm.AddFlow1
    For Each link In linkNuevo.dst.InLinks
        If link Is linkNuevo Then
            link.Marked = False
        Else
            link.Marked = True
        End If
    Next
    grafo.DeleteMarked
    
    'Normalizando Prioridades
    Actualiza_Grafo grafo
End Sub

Public Sub EliminaSeleccion(grafo As AddFlow)
Dim nodo As afNode
'Dim link As afLink
    
    grafo.Repaint = False
    
    'Borra la seleccin
    grafo.DeleteSel
    
    'Busca nodos que quedaron abiertos
    For Each nodo In grafo.Nodes
        nodo.Marked = False
        If EsTransicion(nodo) Then
            If nodo.InLinks.count <> 1 Or nodo.OutLinks.count <> 1 Then
                nodo.Marked = True
            End If
        End If
    Next
    grafo.DeleteMarked
   
    'Actualiza el grafo
    Actualiza_Grafo grafo
    grafo.Repaint = True
End Sub

'Refresca indices y prioridades
Private Sub Actualiza_Grafo(grafo As AddFlow)
Dim nodo As afNode
    grafo.Repaint = False
    'Actualiza el grafo
    Normaliza_Indices grafo, Nothing
    For Each nodo In grafo.Nodes
        If EsEstado(nodo) Then
'Debug.Assert InStr(nodo.Tag, "STATE_4") = 0
            Normaliza_Prioridades nodo, Nothing
        End If
    Next
    grafo.Repaint = True
End Sub

Public Function RastreaEnComentarios(sBuscar As String, sAReemplazar As String, caseSensitive As Boolean) As Boolean
Dim s As String
Dim nodo As afNode
Dim grafo As AddFlow
    
    Set grafo = mainFrm.ActiveForm.AddFlow1
    'Localiza los nodos de texto
    With grafo
        .LogicalOnly = False
        For Each nodo In .Nodes
            If EsComentario(nodo) Then
                s = nodo.Text
                If frmFind.busqueda("Label", s, sBuscar, sAReemplazar, caseSensitive, .readOnly) Then
                    If Not .readOnly Then nodo.Text = s
                    RastreaEnComentarios = True 'Permite seguir buscando
                Else
                    RastreaEnComentarios = False
                    Exit For
                End If
                
            End If
        Next
        .LogicalOnly = True
    End With
End Function
